<?php

// this function loads a data file created using
// the pdftk dump_data_fields option
//
function
load_field_data( $field_report_fn )
{
  $ret_val= array();

  $fp= fopen( $field_report_fn, "r" );
  if( $fp ) {
    $line= '';
    $rec= array();
    while( ($line= fgets($fp, 2048))!== FALSE ) {
      $line= rtrim( $line );
      if( $line== '---' ) {
	if( 0< count($rec) ) { // end of record
	  $ret_val[]= $rec;
	  $rec= array();
	}
	continue;
      }

      $data_pos= strpos( $line, ':' );
      $name= substr( $line, 0, $data_pos+ 1 );
      $value= substr( $line, $data_pos+ 2 );

      if( $name== 'FieldStateOption:' ) {
	if( !array_key_exists( 'FieldStateOption:', $rec ) ) {
	  $rec['FieldStateOption:']= array();
	}
	$rec['FieldStateOption:'][]= $value;
      }
      else {
	$rec[ $name ]= $value;
      }
    }

    if( 0< count($rec)) { // pack final record
      $ret_val[]= $rec;
    }

    fclose( $fp );
  }

  return $ret_val;
}


echo '<html>
<head>
</head>
<body>
<form method="POST" action="pdf_form_fill.php">
<table>';

$field_arr= load_field_data( 'formtx.5.pdf.fields' );

foreach( $field_arr as $field ) {
  echo '<tr><td>';
  if( array_key_exists( 'FieldNameAlt:', $field ) ) {
    echo $field['FieldNameAlt:'];
  }
  else {
    echo $field['FieldName:'];
  }
  echo '</td><td>';

  if( $field['FieldType:']== 'Text' ) {
    // cannot use periods in field names with PHP, so translate them to tildes
    echo '<input type="text" name="'. strtr($field['FieldName:'], '.', '~'). '" ';
    if( array_key_exists( 'FieldValueDefault:', $field ) ) {
      echo 'value="'. $field['FieldValueDefault:']. '" ';
    }
    if( array_key_exists( 'FieldMaxLength:', $field ) ) {
      echo 'maxlength="'. $field['FieldMaxLength:']. '" ';
      if( $field['FieldMaxLength:']< 80 ) {
	echo 'size="'. $field['FieldMaxLength:']. '" ';
      }
      else {
	echo 'size="80" ';
      }
    }
    echo '>';
  }
  else if( array_key_exists( 'FieldStateOption:', $field ) ) {
    echo '<select name="'. strtr($field['FieldName:'], '.', '~'). '">';
    foreach( $field['FieldStateOption:'] as $option ) {
      echo '<option>'.$option.'</option>';
    }
    echo '</select>';
  }
  echo "</td></tr>\n";

}

//var_dump( $field_arr ); // debug

echo '</table>
<input type="submit" value="Create PDF">
</form>
</body>
</html>';
?>
